//CONFIG HERE
LineColor = CreateColor(0, 255, 0, 255);
DotColor = CreateColor(255, 255, 0, 255);
Font = GetSystemFont();
MinFps = 30 //Will start deleting points when it reaches this fps
FixFps = 45 //Will stop above at this fps
//CONFIG END HERE

EvaluateSystemScript("math.js");


FixMode = false;
x = GetScreenWidth() / 2
y = GetScreenHeight() / 2
rx = x;ry = y;
Direction = Math.round(Math.random() * 360);
Points = Array();

cFps = 0;
lFps = GetTime();
Fps = "unknown";
PointDb = Array()

function game() {
  while(!IsKeyPressed(KEY_ESCAPE)) {
		if(GetTime() >= lFps + 1000) {
		  lFps = GetTime();
		  Fps = cFps;
		  cFps = 0;
		}
		cFps++
		Font.drawText(0, 0, "Fps " + Fps + ", Angle: " + Direction + ", Points: " + Points.length)
		Update()
		if(Math.round(x) >= GetScreenWidth()) {x = GetScreenWidth() - 1;Direction = 90 - Direction;}
		if(Math.round(x) <= 0) {x = 1;Direction = 270 - Direction;}
		if(Math.round(y) >= GetScreenHeight()) {y = GetScreenHeight() - 1;Direction = 180 - Direction;}
		if(Math.round(y) <= 0) {y = 1;Direction = 180 - Direction;}
		FixDir();
		for(i=0;i<Points.length;i++) {
			Point(Points[i][0], Points[i][1], LineColor);
		}
		Point(Math.round(x), Math.round(y), DotColor);
		FlipScreen();
		if(!PointDb[Math.round(x) + ","+ Math.round(y)]) {
			Points.push([Math.round(x),Math.round(y)]);
			PointDb[Math.round(x) + ","+ Math.round(y)] = true;
		}
		if(Fps < MinFps && !FixMode) FixMode = true;
		if(Fps > FixFps && FixMode) FixMode = false;
		if(FixMode) {PointDb[Points[0][0] + "," + Points[0][1]] = false; PointDb[Points[1][0] + "," + Points[1][1]] = false;Points.splice(0, 2);}
  }
}


function Update() {
	Direction = Direction + (Math.round(Math.random() * 10) - 5);
	FixDir();
	x += Math.sin(DegreesToRadians(Direction));
	y += Math.cos(DegreesToRadians(Direction));
}

function FixDir() {
	while(Direction < 0) {Direction += 360}
	while(Direction > 360) {Direction -= 360}
}